'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _roles_wrapper = require('./roles_wrapper');

var _roles_wrapper2 = _interopRequireDefault(_roles_wrapper);

var _config_wrapper = require('./config_wrapper');

var _config_wrapper2 = _interopRequireDefault(_config_wrapper);

var _uploads_wrapper = require('./uploads_wrapper');

var _uploads_wrapper2 = _interopRequireDefault(_uploads_wrapper);

var _fees_wrapper = require('./fees_wrapper');

var _fees_wrapper2 = _interopRequireDefault(_fees_wrapper);

var _challenges_wrapper = require('./challenges_wrapper');

var _challenges_wrapper2 = _interopRequireDefault(_challenges_wrapper);

var _sheltering_wrapper = require('./sheltering_wrapper');

var _sheltering_wrapper2 = _interopRequireDefault(_sheltering_wrapper);

var _kyc_whitelist_wrapper = require('./kyc_whitelist_wrapper');

var _kyc_whitelist_wrapper2 = _interopRequireDefault(_kyc_whitelist_wrapper);

var _head_wrapper = require('./head_wrapper');

var _head_wrapper2 = _interopRequireDefault(_head_wrapper);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/*
Copyright: Ambrosus Technologies GmbH
Email: tech@ambrosus.com

This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0. If a copy of the MPL was not distributed with this file, You can obtain one at https://mozilla.org/MPL/2.0/.

This Source Code Form is “Incompatible With Secondary Licenses”, as defined by the Mozilla Public License, v. 2.0.
*/

var ContractManager = function ContractManager(web3, headContractAddress, defaultAddress) {
  (0, _classCallCheck3.default)(this, ContractManager);

  this.headWrapper = new _head_wrapper2.default(headContractAddress, web3, defaultAddress);
  this.rolesWrapper = new _roles_wrapper2.default(this.headWrapper, web3, defaultAddress);
  this.configWrapper = new _config_wrapper2.default(this.headWrapper, web3, defaultAddress);
  this.uploadsWrapper = new _uploads_wrapper2.default(this.headWrapper, web3, defaultAddress);
  this.feesWrapper = new _fees_wrapper2.default(this.headWrapper, web3, defaultAddress);
  this.challengesWrapper = new _challenges_wrapper2.default(this.headWrapper, web3, defaultAddress);
  this.shelteringWrapper = new _sheltering_wrapper2.default(this.headWrapper, web3, defaultAddress);
  this.kycWhitelistWrapper = new _kyc_whitelist_wrapper2.default(this.headWrapper, web3, defaultAddress);
};

exports.default = ContractManager;